# -*- coding:Utf-8 -*-
import es, time, psyco, vecmath, cfglib, effectlib
psyco.full()

config = cfglib.AddonCFG(es.getAddonPath("charg") + "/charg.cfg")
charg_time  = config.cvar("charg_time",  3, "Temps du chargement de l'arme en seconde" )
charg_explode  = config.cvar("charg_explode",  1, "1 = Active la propulsion  d'une entit vise par l'arme")
power_effect  = config.cvar("power_effect",  1, "1 = Active le faisceau de lumire lorsqu'un joueur est tu avec L'arme")
config.write() 

players = {}
es.damage = es.import_addon("corelib/damage").ServerCommandCallBack

def load():
    es.mexec('../addons/eventscripts/charg/charg.cfg')
    es.addons.registerTickListener(TickListenerCallBack)
    es.doblock('corelib/noisy_on')
    es.msg("#multi", "#green Power Module-v1#default by @liVier#lightgreen On !:")
	
def unload():
    es.addons.unregisterTickListener(TickListenerCallBack)
    es.doblock('corelib/noisy_off')
    es.msg("#multi", "#green Power Module-v1#default by @liVier#lightgreen Off!")
	
def player_activate(ev):
	players[int(ev['userid'])] = {}
	
def player_disconnect(ev):
	del players[int(ev['userid'])]
	
def client_keypress(ev):
	userid = int(ev['userid'])
	if ev['keyname'] == 'attack' and ev['es_userweapon'][7:] in ('usp', 'glock'):	    
			if int(ev['status']):
				es.emitsound('player', userid, 'weapons/cguard/charging.wav', 0.5, 0.5)
				players[userid] = time.time()
			elif userid in players:
				es.emitsound('player', userid, 'weapons/shotgun/shotgun_dbl_fire.wav', 0.5, 0.5)             		
				charg = int(time.time()) - int(players[userid])
				del players[userid]			
				es.server.insertcmd('xgetviewprop temp %s;' % userid)
				es.server.insertcmd('xgetviewplayer temp2 %s;' % userid)	
				es.server.insertcmd('es xcallblock charg/xcallblock %s server_var(temp) server_var(temp2) %s ' % (userid, charg))
				
					
						
def xcallblock(userid, index, victime_id, charg):					

	if (es.entitygetvalue(index, "classname") == "prop_physics_multiplayer") and charg_explode == 1:
		explosePhysicProp(userid, index)
	
	if (es.entitygetvalue(index, "classname") == "player"):
		
		if charg < charg_time: 
			es.server.insertcmd('damage %s %s %s %s' % (victime_id, "10", "32", userid))
			
		if charg >= charg_time:
			es.server.insertcmd('damage %s %s %s %s' % (victime_id, "#health", "32", userid))
					
			if power_effect == 1:
				atk = list(es.getplayerlocation(userid))
				atk[2] = atk[2] + 60
				atk[1] = atk[1] + 25
				vic = list(es.getplayerlocation(victime_id))
				vic[2] = vic[2] + 62
				effectlib.drawLine(atk, vic, 'materials/sprites/laserbeam.vmt','materials/sprites/laserbeam.vmt','3','10','10','0','0','255','255','10','0','0','0','0')
											
			

def TickListenerCallBack(): 
	for userid in es.getUseridList():
		weapon = es.createplayerlist(userid)[userid]['weapon']
		if weapon and weapon[7:] in ('usp', 'glock'):
			es.setplayerprop(userid, 'CCSPlayer.baseclass.baseclass.bcc_localdata.m_flNextAttack', es.getplayerprop(userid, 'CCSPlayer.baseclass.baseclass.bcc_localdata.m_flNextAttack') + 1)	
	
	
def explosePhysicProp(userid, index):
   origin = es.entitygetvalue(index, 'origin')
   explose_index = es.createentity("env_physexplosion", ("env_physexplosion_" + str(userid)))
   outputs = {
      "Radius"    : 250,
      "Magnitude" : 500,
      "SpawnFlags": 1,
      "Origin"    : origin
      }
   for output in outputs:
	  es.entitysetvalue(explose_index, output, outputs[output])
	
   es.fire(userid, ("env_physexplosion_" + str(userid)), "Explode")
   es.fire(userid, ("env_physexplosion_" + str(userid)), "Kill")
	